function AIPlayer::AddMotivation(%this, %motivation, %priority, %params)
{
	for(%i = 1; %i <= %this.motivationcount && !%motpos; %i++) {
		if(%this.motivation[%i, name] $= %motivation) %motpos = %i;
	}
	if(%motpos) %this.motivation[%motpos, priority] += %priority;
	else {
		%this.motivationcount++;
		%this.motivation[%this.motivationcount, name] = %motivation;
		%this.motivation[%this.motivationcount, priority] = %priority;
		%this.motivation[%this.motivationcount, params] = %params;
	}
}

function AIPlayer::SubMotivation(%this, %motivation, %priority)
{
	for(%i = 1; %i <= %this.motivationcount && !%motpos; %i++) {
		if(%this.motivation[%i, name] $= %motivation) %motpos = %i;
	}
	if(%motpos) {
		%this.motivation[%motpos, priority] -= %priority;
		if(%this.motivation[%motpos, priority] <= 0 || !%priority) {
			for(%i = %motpos; %i < %this.motivationcount; %i++) {
				%this.motivation[%i, name] = %this.motivation[(%i+1), name];
				%this.motivation[%i, priority] = %this.motivation[(%i+1), priority];
				%this.motivation[%i, params] = %this.motivation[(%i+1), params];
			}
			%this.motivation[%this.motivationcount, name] = "";
			%this.motivation[%this.motivationcount, priority] = "";
			%this.motivation[%this.motivationcount, params] = "";
			%this.motivationcount--;
		}
	}
	//%this.MotivationCheck(); I should work out some way to re-run the check in the same think tick probably
}

function AIPlayer::GetPriority(%this, %motivation)
{
	for(%i = 1; %i <= %this.motivationcount && !%motpos; %i++) {
		if(%this.motivation[%i, name] $= %motivation) %motpos = %i;
	}
	if(%motpos) return %this.motivation[%motpos, priority];
	else return 0;
}

function AIPlayer::GetParams(%this, %motivation)
{
	for(%i = 1; %i <= %this.motivationcount && !%motpos; %i++) {
		if(%this.motivation[%i, name] $= %motivation) %motpos = %i;
	}
	if(%motpos) return %this.motivation[%motpos, params];
	else return 0;
}

function AIPlayer::GetTopPriority(%this)
{
	for(%i = 1; %i <= %this.motivationcount; %i++) {
		if(%this.motivation[%i, priority] >= 100 && %maxp <= %this.motivation[%i, priority]) { //default behavior is motivation 100, newer motivations have higher priorities in a tie.
			%maxp = %this.motivation[%i, priority];
			%maxpos = %i; 
		}
	}
	if(%maxpos) return %this.motivation[%maxpos, name];
	else return "none";
}

function AIPlayer::MotivationCheck(%this, %frontobj, %frontbrick, %muzzleobj, %brickup, %topP)
{
	switch$(%topP) {
		case "reload":
				%this.reloadtime--;
				if(%this.fastreload) %this.reloadtime--;
				if(%this.reloadtime <= 0) {
					%this.reloadtime = 0;
					%this.playthread(0, "armreadyright");
					%this.SubMotivation("reload");
				}
		case "healing":
			%this.addTask("triggeroff()");
			if(!isObject(%this.looking) || %this.looking.dead || %this.looking.looking != %this) {
				%this.SubMotivation("healing");
				if(%this.getTopPriority() $= "none") {
					if(!%this.FindEnemy()) {
						%this.addMotivation("findenemy", 100);
						%this.findRandomDestination(%brickup);
					}
				}
			}
		case "gettinghealed":
			%this.addTask("triggeroff()");
			if(!isObject(%this.healer) || %this.healer.dead || %this.healer.looking != %this) {
				%this.SubMotivation("gettinghealed");
				if(%this.getTopPriority() $= "none") {
					if(!%this.FindEnemy()) {
						%this.addMotivation("findenemy", 100);
						%this.findRandomDestination(%brickup);
					}
				}
			}
		case "breakLoS":
			if(!isObject(%this.getParams("breakLoS")) || %this.getParams("breakLoS").dead || !%frontobj.team || %frontobj.team == %this.team) %this.SubMotivation("breakLoS");
		case "findenemy":
			if(isObject(%this.looking)) %this.SubMotivation("findenemy");
	}
}
