function botfight(%p1, %p2)
{
	$BottomChat1 = "";
	if(isObject(%p1)) { if(!isObject(%p1.BotWarsData)) %p1AI = true; }
	else %p1AI = true;
	if(isObject(%p2)) { if(!isObject(%p2.BotWarsData)) %p2AI = true; }
	else %p2AI = true;
	
	cancel($BotFightTimer);	
	
	
	if(isobject($botfightgame)) $botfightgame.delete();
	
	if(isobject($BotWars::TeamSpawn[1]) && isobject($BotWars::TeamSpawn[2])) {
		%goodspawns = true;
		for(%i = 1; %i <= 5 && %goodspawns; %i++) {
			if(!isobject($BotWars::TeamSpawn[1].brick[%i])) %goodspawns = false;
			if(!isobject($BotWars::TeamSpawn[2].brick[%i])) %goodspawns = false;
		}
	}
	if(!%goodspawns) {
		messageall("", "BAD SPAWNS; ABORTING BOT FIGHT");
		return;
	}
	for(%i = 1; %i <= 5; %i++) {
		if(isObject($BotsTeamOne[%i])) $BotsTeamOne[%i].delete();
		$BotsTeamOne[%i] = new AIPlayer() {
				isBot = true;
				datablock = nametoid(PlayerStandardArmor);
				position = "0 0 0";
				name = "Bot" SPC %i;
				maxpitchspeed = "25";
				maxyawspeed = "25";
				jumpVelocity = 13.8;
				team = 1;
				teamSlot = %i;
		};
		if(isObject($BotsTeamOne[%i]))
		{
			MissionCleanup.add($BotsTeamOne[%i]);
			$BotsTeamOne[%i].client = $BotsTeamOne[%i];
			$BotsTeamOne[%i].player = $BotsTeamOne[%i];
			if(!%p1AI) $BotsTeamOne[%i].name = %p1.BotWarsData.BotName[%i];
		}
	}
	for(%i = 1; %i <= 5; %i++) {
		if(isObject($BotsTeamTwo[%i])) $BotsTeamTwo[%i].delete();
		$BotsTeamTwo[%i] = new AIPlayer() {
				isBot = true;
				datablock = nametoid(PlayerStandardArmor);
				position = "0 0 0";
				name = "Bot" SPC %i;
				maxpitchspeed = "25";
				maxyawspeed = "25";
				jumpVelocity = 13.8;
				team = 2;
				teamSlot = %i;
		};
		if(isObject($BotsTeamTwo[%i]))
		{
			MissionCleanup.add($BotsTeamTwo[%i]);
			$BotsTeamTwo[%i].client = $BotsTeamTwo[%i];
			$BotsTeamTwo[%i].player = $BotsTeamTwo[%i];
			if(!%p2AI) $BotsTeamTwo[%i].name = %p2.BotWarsData.BotName[%i];
		}
	}
	$botfightgame = new ScriptObject() {
		class = MiniGameSO;
		fallingDamage = true;
		inviteOnly = true;
		playerDatablock = nametoid(PlayerStandardArmor);
		SelfDamage = true;
		VehicleDamage = true;
		WeaponDamage = true;
		teamOwner1 = (%p1AI ? "AI" : %p1);
		teamOwner2 = (%p2AI ? "AI" : %p2);
		botWarsGame = true;
	};
	if(!%p1AI) $botfightgame.teamOwnerName1 = %p1.name;
	if(!%p2AI) $botfightgame.teamOwnerName2 = %p2.name;
	MissionCleanup.add($botfightgame);
	
	for(%i = 1; %i <= 5; %i++) {
		$botfightgame.addbot($BotsTeamOne[%i]);
		$botfightgame.addbot($BotsTeamTwo[%i]);
		$BotsTeamOne[%i].setbotteam(1);
		$BotsTeamTwo[%i].setbotteam(2);
		$BotsTeamOne[%i].settransform(vectoradd($BotWars::TeamSpawn[1].brick[%i].gettransform(), "0 0 -1.45"));
		$BotsTeamTwo[%i].settransform(vectoradd($BotWars::TeamSpawn[2].brick[%i].gettransform(), "0 0 -1.45"));
		$BotsTeamOne[%i].targetPoint = vectorscale($BotsTeamOne[%i].getEyeVector(), 50);
		$BotsTeamTwo[%i].targetPoint = vectorscale($BotsTeamTwo[%i].getEyeVector(), 50);
		$BotsTeamOne[%i].addMotivation("findenemy", 100);
		$BotsTeamTwo[%i].addMotivation("findenemy", 100);
		$BotsTeamOne[%i].wanderspam = true;
		$BotsTeamTwo[%i].wanderspam = true;
		schedule(200, 0, "nowanderspam", $BotsTeamOne[%i]);
		schedule(200, 0, "nowanderspam", $BotsTeamTwo[%i]);
		$BotsTeamOne[%i].schedule(getrandom(0, 100), "think");
		$BotsTeamTwo[%i].schedule(getrandom(0, 100), "think");
		$BotsTeamOne[%i].movey = 1;
		$BotsTeamTwo[%i].movey = 1;
		$BotsTeamOne[%i].moving = 1;
		$BotsTeamTwo[%i].moving = 1;
	}
	if(%p1AI) BWrandomloadout(1);
	if(%p2AI) BWrandomloadout(2);
	
	equipbots(%p1Ai, %p2AI);
	readybotweapons();
	$BotFightTimer = schedule(180000, 0, "BotFightTimeOver");
	messageall("", "\c6New bot fight initiated at " @ $BotWars::SpawnsName @ " spawns: \c1" @ (%p1AI ? "random items" : $botfightgame.teamOwnerName1) @ " \c6vs. \c0" @ (%p2AI ? "random items" : $botfightgame.teamOwnerName2) @ "\c6.");
}

function endBotFight()
{
	for(%i = 1; %i <= 5; %i++) {
		if(isObject($BotsTeamOne[%i])) $BotsTeamOne[%i].delete();
		$BotsTeamOne[%i] = "";
		if(isObject($BotsTeamTwo[%i])) $BotsTeamTwo[%i].delete();
		$BotsTeamTwo[%i] = "";
	}
	$botfightgame.delete();
}

function BWrandomloadout(%team)
{
	%budget = buyRandomWeapons(%team, $BotWars::Store[budget]);
	buyrandomstuff(%team, %budget);
}

function buyrandomweapons(%team, %budget)
{
	for(%i = 1; %i <= 5; %i++) {
		%rnd = getRandom(1, $BotWars::Store[weapons, index]);
		switch(%team) {
			case 1:
				%bot = $BotsTeamOne[%i];
			case 2:
				%bot = $BotsTeamTwo[%i];
		}
		%bot.AIpurchases = 1;
		%bot.AIpurchase[1] = $BotWars::Store[weapons, %rnd];
		%budget -= $BotWars::Store[weapons, %rnd].price;
	}
	return %budget;
}

function buyrandomstuff(%team, %budget)
{
	for(%i = 1; %i <= $BotWars::Store[nonweapons, index]; %i++) {
		%list[%i] = $BotWars::Store[nonweapons, %i];
	}
	while(!%done) {
		%failsafe++;
		for(%i = 1; %list[%i]; %i++) if(%list[%i].price > %budget) for(%j = %i; %list[%j]; %j++) %list[%j] = %list[%j+1]; //remove too-expensive items from the list
		for(%i = 1; %i <= 5; %i++) {
			switch(%team) {
				case 1:
					%bot = $BotsTeamOne[%i];
				case 2:
					%bot = $BotsTeamTwo[%i];
			}
			for(%j = 1; %list[%j]; %j++) {
				if(AIequipAllowed(%bot, %list[%j])) {
					%uberlist[index]++;
					%uberlist[%uberlist[index]] = %bot SPC %list[%j];
				}
			}
		}
		if(%uberlist[index]) {
			%rnd = getRandom(1, %uberlist[index]);
			%bot = getword(%uberlist[%rnd], 0);
			%purchase = getword(%uberlist[%rnd], 1);
			%bot.AIpurchases++;
			%bot.AIpurchase[%bot.AIpurchases] = %purchase;
			%budget -= %purchase.price;
			%uberlist[index] = 0;
		} else %done = true;
		if(%failsafe > 100) %done = true;
	}
}

function AIequipAllowed(%bot, %new)
{
	for(%i = 1; %i <= %new.restrictionCount; %i++) {
		%res = %new.restriction[%i];
		%restype = getword(%res, 0);
		%resparam = getword(%res, 1);
		switch$(%restype) {
			case "forbid":
				%OK = true;
			case "require":
				%OK = false;
		}
		for(%j = 1; %j <= %bot.AIpurchases; %j++) {
			if(%bot.AIpurchases.tag $= %resparam) {
				switch$(%restype) {
					case "forbid":
						%OK = false;
					case "require":
						%OK = true;
				}
			}
		}
		if(!%OK) return false;
	}
	for(%i = 1; %i <= %bot.AIpurchases; %i++) {
		if(%bot.AIpurchase[%i] == %new) return false;
		if(%bot.AIpurchase[%i].slot $= %new.slot) return false;
	}
	return true;
}

function equipbots(%p1AI, %p2AI)
{
	//echo("equipbots(" @ %p1AI @ ", " @ %p2AI @ ");");
	for(%i = 1; %i <= 5; %i++) {
		%bot = $BotsTeamOne[%i];
		if(%p1AI) equipAIbot(%bot);
		else equipbot(%bot, 1);
		%bot = $BotsTeamTwo[%i];
		if(%p2AI) equipAIbot(%bot);
		else equipbot(%bot, 2);
	}
}

function equipbot(%bot, %team) {
	for(%i = 1; %i <= $botfightgame.teamOwner[%team].BotWarsData.botEquipment[%bot.teamSlot, index]; %i++) {
		equipActual(%bot, $botfightgame.teamOwner[%team].BotWarsData.botEquipment[%bot.teamSlot, %i].tag, %team);
	}
}

function equipAIbot(%bot)
{
	for(%i = 1; %i <= %bot.AIpurchases; %i++) {
		equipActual(%bot, %bot.AIpurchase[%i].tag, "AI");
	}
}

function equipActual(%bot, %tag, %source)
{
	switch$(%tag) {
		case "pistol":
			%bot.tool0 = nametoID(gunItem);
			%bot.weapon = "gun";
			%bot.weaponreload = 2;
		case "rocket":
			%bot.tool0 = nametoID(rocketLauncherItem);
			//%bot.setnodecolor("headskin", "0.5 1 0.3 1");
			%bot.weapon = "rocketlauncher";
			%bot.weaponreload = 50;
		case "sword":
			%bot.tool0 = nametoID(swordItem);
			//%bot.unhideNode($hat[1]);
			//%bot.setnodecolor($hat[1], "0.7 0.7 0.7 1");
			%bot.weapon = "sword";
		case "medic":
			%bot.isMedic = true;
			%bot.setNodeColor("larm", "1 1 1 1");
			%bot.setNodeColor("rarm", "1 1 1 1");
			%bot.setNodeColor("pants", "1 1 1 1");
		case "berserker":
			%bot.setnodecolor("headskin", "1 0.3 0 1");
			%bot.setFaceName("memeGrinMan");
			%bot.berserker = 1;
		case "akimboguns":
			%bot.tool0 = nametoID(AkimboGunItem);
			%bot.weapon = "akimboguns";
			%bot.weaponreload = 1;
		case "bow":
			%bot.tool0 = nametoID(BowItem);
			%bot.weapon = "bow";
			%bot.weaponreload = 5;
		case "armor":
			%bot.armor = 1;
			%bot.setDecalName("Medieval-Eagle");
		case "vampiric":
			%bot.vampiric = true;
			%bot.setNodeColor("lhand", "0.6 0 0 1");
			%bot.setNodeColor("rhand", "0.6 0 0 1");
		case "fastreload":
			%bot.fastreload = true;
			%bot.setNodeColor("lhand", "0.6 0.6 0.6 1");
			%bot.setNodeColor("rhand", "0.6 0.6 0.6 1");
		case "agile":
			if(%bot.getdatablock().getname() $= "PlayerStandardArmor") {
				%bot.setDatablock(PlayerAgileArmor);
				%bot.setbotteam(%bot.team);
				%bot.setNodeColor("lshoe", "0 1 1 1");
				%bot.setNodeColor("rshoe", "1 0 0 1");
				%bot.jumpVelocity = 16.9;
				if(%source $= "AI") equipAIbot(%bot);
				else equipbot(%bot, %source);
			}
		case "superspeed":
			if(%bot.getdatablock().getname() $= "PlayerStandardArmor") {
				%bot.setDatablock(PlayerSuperSpeedArmor);
				%bot.setbotteam(%bot.team);
				%bot.setNodeColor("lshoe", "1 0 0 1");
				%bot.setNodeColor("rshoe", "1 0 0 1");
				if(%source $= "AI") equipAIbot(%bot);
				else equipbot(%bot, %source);
			}
		case "superjump":
			%bot.setNodeColor("lshoe", "0 1 1 1");
			%bot.setNodeColor("rshoe", "0 1 1 1");
			%bot.jumpVelocity = 19.52;
		case "criticalhits":
			%bot.critchance = 33;
			%bot.setNodeColor("lhand", "0 0.6 0.45 1");
			%bot.setNodeColor("rhand", "0 0.6 0.45 1");
	}
}

function AIPlayer::setbotteam(%this, %team)
{
	%this.SetDefaultAppearance();
	switch(%team) {
		case 1:
			%this.setnodecolor("chest", "0 0 1 1");
			%this.setNodeColor("larm", "0 0 1 1");
			%this.setNodeColor("rarm", "0 0 1 1");
			%this.setNodeColor("pants", "0 0 1 1");
		case 2:
			%this.setnodecolor("chest", "1 0 0 1");
			%this.setNodeColor("larm", "1 0 0 1");
			%this.setNodeColor("rarm", "1 0 0 1");
			%this.setNodeColor("pants", "1 0 0 1");
	}
}

function ScriptObject::AddBot(%this, %bot)
{
	//%this.addmember(%bot); badspot locked out non-clients from using addmember, so we need to find a hack for it...
	%this.member[%this.numMembers] = %bot;
	%this.numMembers++;
	%bot.minigame = %this;
	if(%this.member == %bot) %this.member0 = %bot;
	%bot.setdatablock(nametoid(PlayerStandardArmor));
	//switch$(%bot.botclass) {
	//	case "pistol":
	//		%bot.tool0 = nametoID(gunItem);
	//	case "rocket":
	//		%bot.tool0 = nametoID(rocketlauncheritem);
	//	case "medic":
	//		%bot.tool0 = nametoID(bowItem);
	//	case "sword":
	//		%bot.tool0 = nametoID(swordItem);
	//}
	//%bot.tool0 = %this.startequip0;
	//%bot.tool1 = %this.startequip1;
	//%bot.tool2 = %this.startequip2;
	//%bot.tool3 = %this.startequip3;
	//%bot.tool4 = %this.startequip4;
}