
function servercmdobservebots(%client)
{
	if(%client.observebots) {
		%client.observebots = false;
		%client.setcontrolobject(%client.player);
		messageclient(%client, "", "\c2No longer observing bots.");
	} else {
		%client.observebots = true;
		attachclienttobot(%client);
		messageclient(%client, "", "\c2Observing bots.");
	}
}

function servercmdpausebots(%admin)
{
	if(!%admin.issuperadmin) return;
	$botspaused = true;
	for(%i = 0; %i < $botfightgame.numMembers; %i++) {
		%bot = $botfightgame.member[%i];
		if(isObject(%bot)) %bot.halt();
	}
}

function servercmdunpausebots(%admin)
{
	if(!%admin.issuperadmin) return;
	$botspaused = false;
	for(%i = 0; %i < $botfightgame.numMembers; %i++) {
		%bot = $botfightgame.member[%i];
		if(isObject(%bot)) %bot.think();
	}
}

function attachclienttobot(%client)
{
	%client.observingmember = getrandom(0, $botfightgame.numMembers);
	%bot = $botfightgame.member[%client.observingmember];
	%client.setcontrolobject(%client.camera);
	%client.camera.setorbitmode(%bot, "0 0 5 0 0 1 0", 0, 5, 0, 0);
	%client.observedbot = %bot;
	schedule(1000, 0, "botobserverupdate", %client);
}

function botObserverUpdate(%client, %dead)
{
	if(!isobject(%client) || !%client.observebots) return;
	if(!isobject(%client.observedbot) || %dead >= 2) {
		if(!isObject($botfightgame)) {
			schedule(1000, 0, "botobserverupdate", %client);
			return;
		}
		%client.observingmember = getrandom(0, $botfightgame.numMembers);
		%bot = $botfightgame.member[%client.observingmember];
		%client.setcontrolobject(%client.camera);
		%client.camera.setorbitmode(%bot, "0 0 5 0 0 1 0", 0, 5, 0, 0);
		%client.observedbot = %bot;
		%dead = false;
	} else if(%client.observedbot.dead) %dead++;
	else %dead = false;
	schedule(1000, 0, "botobserverupdate", %client, %dead);
}

function serverCmdSetBotSpawns(%client, %target)
{
	if(!%client.isadmin && !$BotWars::AllowClientSpawnChange) return;
	%target = findclientbyname(%target);
	if(!isobject(%target)) {
		messageclient(%client, "", "Client not found; no spawns selected.");
		$BotWars::TeamSpawn[1] = "";
		$BotWars::TeamSpawn[2] = "";
		return;
	} 
	%error = setupBWSpawns(%target.brickGroup);
	if(%error !$= "good") {
		messageclient(%client, "", "Client has bad spawn count (" @ getword(%error, 0) @ ", " @ getword(%error, 1) @ "); no spawns selected.");
		$BotWars::TeamSpawn[1] = "";
		$BotWars::TeamSpawn[2] = "";
		return;
	}
	$BotWars::TeamSpawn[1] = %target.brickgroup.botteam1spawns;
	$BotWars::TeamSpawn[2] = %target.brickgroup.botteam2spawns;
	$BotWars::SpawnsName = %target.name;
	messageall("", %target.name SPC "spawn points selected.");
}

function servercmdbotfight(%client, %target1, %target2)
{
	if(!%client.isadmin && !$BotWars::AllowClientGames) return;
	if(%target1 !$= "") %target1 = findclientbyname(%target1);
	if(%target2 !$= "") %target2 = findclientbyname(%target2);
	botfight(%target1, %target2);
}

function serverCmdEndBotFight(%client)
{
	if(!%client.isadmin && !$BotWars::AllowClientGames) return;
	if(!isObject($botFightGame)) return;
	endBotFight();
	messageAll("", "Bot fight aborted by" SPC %client.name @ ".");
}

function servercmdbotname(%client, %slot, %a, %b, %c, %d, %e, %f, %g, %h, %i, %j)
{
	if(!isObject(%client.botwarsdata) || %slot < 1 || %slot > 5) return;
	%slot = mfloor(%slot);
	%name = getsubstr(trim(%a SPC %b SPC %c SPC %d SPC %e SPC %f SPC %g SPC %h SPC %i SPC %j), 0, 25);
	%client.botwarsdata.botname[%slot] = %name;
	commandToClient(%client, 'BotWarsGUIGetData', "botname", %slot, %name);
	messageclient(%client, "", "Bot name " @ %slot @ " set to \"" @ %name @ "\".");
}